(in-package  :examples)
(use-package :oli)

(sd-defdialog 'sd-exemplaranzeige
  :dialog-title "Exemplaranzeige"
  :toolbox-button t
  :after-initialization
  '(progn
     (sd-set-variable-status 'Exemplare_anz :enable nil)
     (sd-set-variable-status 'Bericht :enable nil)
   )
  :variables
  '(("Besitzerangabe")
    (Besitzer      :value-type :assembly
                   :title "Baugr.:"
                   :prompt-text "Besitzer-Baugruppe angeben."
                   :initial-value nil
                   :multiple-items nil
                   :modifies nil
                   :after-input
                   (progn
                     (setf Objekte nil)
                     (setf Anzahl nil)
                     (sd-set-variable-status 'Exemplare_anz :enable nil)
                     (sd-set-variable-status 'Bericht :enable nil)
                   )
    )
    ("Exemplarangabe")
    (Objekte       :selection (*sd-part-seltype* *sd-assembly-seltype*)
                   :face-part-allowed t
                   :show-select-menu nil
                   :multiple-items t
                   :title "Teil/Bgr.:"
                   :prompt-text "Teil(e) und/oder Baugruppe(n) angeben."
                   :initial-value nil
                   :after-input
                   (progn
                     (if (= (length Objekte) 1)
                       (progn
                         (exemplare-anzahl (nth 0 Objekte) Besitzer)
                         (if (> Anzahl_nummer 1)
                           (progn
                             (sd-set-variable-status 'Exemplare_anz :enable t)
                             (sd-set-variable-status 'Bericht :enable nil)
                           )
                           (progn
                             (sd-set-variable-status 'Exemplare_anz :enable nil)
                             (sd-set-variable-status 'Bericht :enable nil)
                           )
                         )
                       )
                       (progn
                         (setf Anzahl (format nil "s. Bericht" Anzahl_nummer))
                         (sd-set-variable-status 'Exemplare_anz :enable nil)
                         (sd-set-variable-status 'Bericht :enable t)
                       )
                     )
                   )
    )
    ("-")
    ("Einzelabfrage - Ergebnis:")
    (Anzahl        :value-type :display-only
                   :title "Gesamt-Anz.:"
                   :value-visibility-alignment :left
    )
    (Exemplare_anz :title "Alle Exemplare anzeigen"
                   :toggle-type :wide-toggle
                   :push-action
                   (progn
                     (exemplare-anzeigen (nth 0 Objekte) Besitzer)
                   )
    )
    ("-")
    ("Mehrfachabfrage - Ergebnis:")
    (Bericht       :title "Bericht ausgeben."
                   :toggle-type :wide-toggle
                   :push-action
                   (progn
                     (bericht-ausgeben Besitzer Objekte)
                   )
    )
  )
  :local-functions
    '((exemplare-anzahl (Exemplar Besitzer)
        (let (System-id-name Alle_elemente Element)
          (setf System-id-name (sd-inq-obj-contents-sysid Exemplar))
          (setf Alle_elemente (sd-call-cmds
                                (get_selection :focus_type (list *sd-part-seltype* *sd-assembly-seltype*)
                                  :check_function #'(lambda (pseudo)
                                  (if (string= System-id-name (sd-inq-obj-contents-sysid pseudo))
                                    :ok
                                    :filter
                                  )
                                )
                                :select :recursive :in_assembly Besitzer
                                )
                                :failure (display (format nil "~a ~%=> Beim Ermitteln der Exemplar-Anzahl !" (sd-inq-error-obj :message)))
                              )
          )
          (setf Anzahl_nummer (list-length Alle_elemente))
          (setf Anzahl (format nil "~a Stck" Anzahl_nummer))
        )
      )

      (exemplare-anzeigen (Exemplar Besitzer)
        (let (System-id-name Alle_elemente Element)
          (setf System-id-name (sd-inq-obj-contents-sysid Exemplar))
          (setf Alle_elemente (sd-call-cmds
                                (get_selection :focus_type (list *sd-part-seltype* *sd-assembly-seltype*)
                                  :check_function #'(lambda (pseudo)
                                  (if (string= System-id-name (sd-inq-obj-contents-sysid pseudo))
                                    :ok
                                    :filter
                                  )
                                )
                                :select :recursive :in_assembly Besitzer
                                )
                                :failure (display (format nil "~a ~%=> Beim Anzeigen der Exemplare !" (sd-inq-error-obj :message)))
                              )
          )
          (sd-call-cmds
            (create_vp
              :corner_1 (make-gpnt2d :x 188 :y 0)
              :corner_2 (make-gpnt2d :x 842 :y 496)
            )
          )
          (uic_set_vp_direction -1.0,3.0,-1.0 (oli::sd-inq-current-vp))

          (dolist (Element Alle_elemente)
            (sd-call-cmds (add_to_vp_drawlist (oli::sd-inq-current-vp) Element)
              :failure (display (format nil "~a ~%=> Beim Anzeigen der Exemplare im DF-Fenster!" (sd-inq-error-obj :message)))
            )
            (fit_vp (oli::sd-inq-current-vp))
          )
        )
      )

      (bericht-ausgeben (Besitzer objectliste)
        (let (Anzahl_nummer_korrektur)
          (progn
            (display :clear-hide)
            (display "----------------------------------------")
            (display "Exemplaranzahl - Bericht fuer Baugruppe:")
            (display (sd-inq-obj-basename Besitzer))
            (display "----------------------------------------")
            (dolist (object objectliste)
              (progn
                (exemplare-anzahl object Besitzer)
                ;; Leerstellen hinzufuegen
                (setf Anzahl (format nil "s. Bericht" Anzahl_nummer))
                (when (equal (length (sd-num-to-string Anzahl_nummer)) 1)
                  (setf Anzahl_nummer_korrektur (format nil "~a  " Anzahl_nummer))
                )
                (when (equal (length (sd-num-to-string Anzahl_nummer)) 2)
                  (setf Anzahl_nummer_korrektur (format nil "~a " Anzahl_nummer))
                )
                (display (format nil "~a Stk | ~a" Anzahl_nummer_korrektur (sd-inq-obj-basename object)))
              )
            )
            (display "----------------------------------------")
          )
        )
      )
    )
  :ok-action
  '()
  :cancel-action
  '()
)




